<?php

namespace jrosset\Collections;

/**
 * Interface for classes comparing external objects
 *
 * @template TObject of object
 */
interface IComparator {
    /**
     * Compare two objects
     *
     * @param TObject $object1 The first object
     * @param TObject $object2 The second object
     *
     * @return int <br>&lt; 0 if the first object is classed before the second object
     *             <br>= 0 if the first object is classed equals the second object
     *             <br>&gt; 0 if the first object is classed after the second object
     *
     * @noinspection PhpMissingParamTypeInspection
     */
    public function compare ($object1, $object2): int;
}