<?php

namespace jrosset\Collections;

/**
 * Implementation for unique collection
 *
 * @template TKey of array-key
 * @template TValue
 */
trait TUniqueValues {
    /**
     * @inheritDoc
     */
    protected function _set ($key, $value): static {
        if ($this->contains($value)) {
            return $this;
        }

        $this->elements[$this->_normalizeKey($key)] = $value;
        return $this;
    }
    /**
     * @inheritDoc
     */
    protected function _add (...$values): static {
        foreach ($values as $value) {
            if ($this->contains($value)) {
                continue;
            }
            $this->elements[] = $value;
        }
        return $this;
    }
}