<?php

use jrosset\Collections\ImmutableCollection;
use jrosset\Collections\InsensitiveCaseKeyCollection;
use jrosset\Collections\InsensitiveCaseKeyImmutableCollection;

require_once __DIR__ . '/../vendor/autoload.php';

$readOnlyCollection = new InsensitiveCaseKeyImmutableCollection(
    [
        'Foo' => 'bar',
        'foo' => 'foobar',
    ]
);

echo 'Size : ' . $readOnlyCollection->count() . PHP_EOL;
echo 'Foo = ' . $readOnlyCollection->get('Foo') . PHP_EOL;
echo '-----' . PHP_EOL;

$collection = new InsensitiveCaseKeyCollection($readOnlyCollection);
$collection->add(28);
echo 'Size : ' . $collection->count() . PHP_EOL;

echo 'Fill :' . PHP_EOL;
foreach (ImmutableCollection::fill(5, -1) as $key => $value) {
    echo "\t#" . $key . ' = ' . $value . PHP_EOL;
}